xdel(winsid())
// # points in plot
n_plt = 5;
// 95%
circle_mult = 2.4477; // For drawing covariance circles in scatter plot.
// For drawing "yard lines"
Envy_param = [-2,4,5] // number back,number forward, step
Well_param = [-2,3,5]
Envy_paramS = [-2,4,5] // number back,number forward, step
Well_paramS = [-2,4,4]

msize = 10;
rand("uniform")
// Model parameters (see paper for significance)
N = 10000;
T = 200;    
k = [.75:0.5:2.25];// Tradeoff rates 
q_vals = [0.75];// Overvaluation factor
sigma = 1;
phi = 0.5;
s_1 = sigma;
s_2 = phi*sigma;
pvals = [0.0,0.1];// turnover probabilities
f = .2  // new lifestyle choice rate
p = pvals(1); // first p value
nsim = size(k,"*");

// for other plots
ellipse_plot = 0; // Flag for plotting covariance ellipses
ellipse2_plot = 1;
pop_sample = 200; // Size of random sample plotted
npts_ellipse = 200;
Scatter_final = zeros(pop_sample,2*nsim*2)

// Initialize q_n for individuals (in the case of an inhomogeneous population
nq = size(q_vals,"*");
q_sz = floor(N/nq)
q_left = N - nq*q_sz
//Find boundaries
q_bdry = q_sz*[0:1:nq];
for ii = 1:1:q_left
    q_bdry(ii+1:$) = q_bdry(ii+1:$)+1;
end
q = zeros(1,N);
for ii = 1:1:nq
    q(q_bdry(ii)+1:q_bdry(ii+1))=q_vals(ii);
end

plt_step = floor(T / n_plt); // Printing
T = plt_step*n_plt; // adjust time

// Initialize averages and variances
MuA = zeros(n_plt+1,2*nsim);
MuB = MuA;
VarA = MuA;
VarB = MuA;
CovAB = MuA;

function [MuTmpA,MuTmpB,VarTmpA,VarTmpB,CovTmpAB,Scatter_tmp] = ModelCalc(k,s_1,s_2,N,T,q,p,f,n_plt,pop_sample);
    MuTmpA = zeros(n_plt+1,1);
    MuTmpB = MuTmpA;
    VarTmpA = MuTmpA;
    VarTmpB = MuTmpA;
    CovTmpAB = MuTmpA;
    
    den = sqrt(1+k^2);
    costh = 1/den;
    sinth = k/den;
    Mx = [costh*s_1,sinth*s_2 ; -sinth*s_1, costh*s_2];
    W = Mx*rand(2,N,"normal");
    MuW = mean(W,2);
    jj = 1;
    MuTmpA(jj) = MuW(1);
    MuTmpB(jj) = MuW(2);
    cov_temp = mvvacov(W');
    VarTmpA(jj) = cov_temp(1,1);
    VarTmpB(jj) = cov_temp(2,2);
    CovTmpAB(jj) = cov_temp(1,2);
    // Iterate over time
    for t = 1:1:T
        w = Mx*rand(2,N,"normal");
        w(1,:) = w(1,:)+MuW(1);
        w(2,:) = w(2,:)-k*MuW(1);
        criteria = (w(2,:) + (1+q).*w(1,:) > W(2,:) + (1+q).*W(1,:));
        criteria = ((criteria + (1-criteria).*(rand(1,N,"uniform")<p))).*(rand(1,N,"uniform")<f);
        diffW = w-W;
        W(1,:) = W(1,:)+ criteria.*diffW(1,:);
        W(2,:) = W(2,:) + criteria.*diffW(2,:);
        MuW = mean(W,2);
        if pmodulo(t,plt_step)==0
            jj = t/plt_step+1;
            MuTmpA(jj) = MuW(1);
            MuTmpB(jj) = MuW(2);
            cov_temp = mvvacov(W');
            VarTmpA(jj) = cov_temp(1,1);
            VarTmpB(jj) = cov_temp(2,2);
            CovTmpAB(jj) = cov_temp(1,2);
        end
    end
    Scatter_tmp = W(1:2,1:pop_sample)'
endfunction

for ii = 1:1:2*nsim
    if ii > nsim
        p = pvals(2)
        kk = k(ii-nsim)
    else
        kk = k(ii);
    end
    
    disp(ii)
    [MuTmpA,MuTmpB,VarTmpA,VarTmpB,CovTmpAB,Scatter_tmp] = ModelCalc(kk,s_1,s_2,N,T,q,p,f,n_plt,pop_sample);
    MuA(:,ii) = MuTmpA;
    MuB(:,ii) = MuTmpB;
    VarA(:,ii) = VarTmpA;
    VarB(:,ii) = VarTmpB;
    CovAB(:,ii) = CovTmpAB;
    Scatter_final(:,2*ii-1:2*ii) = Scatter_tmp;
end
f = figure(1)
clf()
f.background = -2;
plot(MuA(:,(1:nsim)),MuB(:,(1:nsim)),".",'markersize',msize)
plot(MuA(:,nsim+(1:nsim)),MuB(:,nsim+(1:nsim)),"*",'markersize',msize/2+1)
legend(["k=0.75","k=1.25","k=1.75","k=2.25"],with_box = %t)
title(['Evolution of system: Time = ',msprintf('%3.1f',T),', q =',msprintf('%1.2f',q_vals(1)),'$ \phi =$',msprintf('%1.2f',phi),'$ p =$',msprintf('%1.2f',p)],'fontsize',3)
xlabel('Conspicuous well-being index','fontsize',3)
ylabel('Inconspicuous well-being index','fontsize',3)
aaa = get("current_axes")
aaa.children(1).font_size = 3;

Circle = [cos(2*%pi*linspace(0,1,npts_ellipse));sin(2*%pi*linspace(0,1,npts_ellipse))]';
Ellipses = zeros(npts_ellipse,2*nsim)
if ellipse_plot==1
for ii = 1:1:nsim
jj = n_plt+1
        Cov_tmp = inv([VarA(jj,ii), CovAB(jj,ii) ; CovAB(jj,ii) , VarB(jj,ii)]);
        mult_tmp = sqrt(diag(Circle*Cov_tmp*Circle'));
        Circle_tmp = [Circle(:,1)./mult_tmp , Circle(:,2)./mult_tmp];
        Ellipses(:,2*ii-1:2*ii) = [circle_mult*Circle_tmp(:,1) + MuA(jj,ii),circle_mult*Circle_tmp(:,2) + MuB(jj,ii)];
end
plot(Ellipses(:,1),Ellipses(:,2),'-',Ellipses(:,3),Ellipses(:,4),'-',Ellipses(:,5),Ellipses(:,6),'-',Ellipses(:,7),Ellipses(:,8),'-')
end
//put on lines
a = get("current_axes")     
bds = a.data_bounds;
for iie = Envy_param(1):Envy_param(2)
    envy_tmp = Envy_param(3)*iie;
    y1 = envy_tmp - (1+q(1))*bds(1,1);
    if y1 < bds(2,2)
        pt0 = [bds(1,1),y1];
    else
        pt0 = [(envy_tmp - bds(2,2))/(1+q(1)),bds(2,2)];
    end
    y1 = envy_tmp - (1+q(1))*bds(2,1);
    if y1 > bds(1,2)
        pt1 = [bds(2,1),y1];
    else
        pt1 = [(envy_tmp - bds(1,2))/(1+q(1)),bds(1,2)];
    end
    pts = [pt0 ; pt1];
    plot(pts(:,1),pts(:,2),'k:','thickness',1)
end
for iie = Well_param(1):Well_param(2)
    well_tmp = Well_param(3)*iie;
    y1 = well_tmp - bds(1,1);
    if y1 < bds(2,2)
        pt0 = [bds(1,1),y1];
    else
        pt0 = [(well_tmp - bds(2,2)),bds(2,2)];
    end
    y1 = well_tmp - bds(2,1);
    if y1 > bds(1,2)
        pt1 = [bds(2,1),y1];
    else
        pt1 = [(well_tmp - bds(1,2)),bds(1,2)];
    end
    pts = [pt0 ; pt1];
    plot(pts(:,1),pts(:,2),'k-','thickness',1)
end
f = figure(2)
clf()
f.background = -2;
plot(plt_step*(0:1:n_plt),MuA(:,1:nsim)+MuB(:,1:nsim),'o:','thickness',2,'markersize',msize)
plot(plt_step*(0:1:n_plt),MuA(:,nsim+1:2*nsim)+MuB(:,nsim+1:2*nsim),'.:','thickness',1,'markersize',1)

legend(["k=0.75","k=1.25","k=1.75","k=2.25"],opt=2,with_box = %t)
aaa = get("current_axes")
aaa.children(1).font_size = 3;
       
xlabel('time (""years"")','fontsize',3)
ylabel('""Actual"" well-being','fontsize',3)
title(['Evolution of system: Time = ',msprintf('%3.1f',T),', q =',msprintf('%1.2f',q_vals(1)),'$ \phi =$',msprintf('%1.2f',phi),'$ p =$',msprintf('%1.2f',p)],'fontsize',3)
f= figure(4)
clf()
f.background = -2;
plot(Scatter_final(:,2*nsim+1),Scatter_final(:,2*nsim+2),'+',Scatter_final(:,2*nsim+3),Scatter_final(:,2*nsim+4),'+',Scatter_final(:,2*nsim+5),Scatter_final(:,2*nsim+6),'+',Scatter_final(:,2*nsim+7),Scatter_final(:,2*nsim+8),'+')
// Put in 95% circles
if ellipse2_plot > 0
Ellipses = zeros(npts_ellipse,2*nsim)
for ii = 1:1:nsim
jj = n_plt+1
    den = sqrt(1+k(ii)^2);
    costh = 1/den;
    sinth = k(ii)/den;
    Mx = [costh*s_1,sinth*s_2 ; -sinth*s_1, costh*s_2];
    Circle_tmp = Circle*Mx';
        Ellipses(:,2*ii-1:2*ii) = [circle_mult*Circle_tmp(:,1) + MuA(jj,nsim+ii),circle_mult*Circle_tmp(:,2) - k(ii)*MuA(jj,nsim+ii)];
end
plot(Ellipses(:,1),Ellipses(:,2),'-',Ellipses(:,3),Ellipses(:,4),'-',Ellipses(:,5),Ellipses(:,6),'-',Ellipses(:,7),Ellipses(:,8),'-')
end

//put on lines
a = get("current_axes")     
bds = a.data_bounds;
for iie = Envy_paramS(1):Envy_paramS(2)
    envy_tmp = Envy_paramS(3)*iie;
    y1 = envy_tmp - (1+q(1))*bds(1,1);
    if y1 < bds(2,2)
        pt0 = [bds(1,1),y1];
    else
        pt0 = [(envy_tmp - bds(2,2))/(1+q(1)),bds(2,2)];
    end
    y1 = envy_tmp - (1+q(1))*bds(2,1);
    if y1 > bds(1,2)
        pt1 = [bds(2,1),y1];
    else
        pt1 = [(envy_tmp - bds(1,2))/(1+q(1)),bds(1,2)];
    end
    pts = [pt0 ; pt1];
    plot(pts(:,1),pts(:,2),'k:','thickness',1)
end
for iie = Well_paramS(1):Well_paramS(2)
    well_tmp = Well_paramS(3)*iie;
    y1 = well_tmp - bds(1,1);
    if y1 < bds(2,2)
        pt0 = [bds(1,1),y1];
    else
        pt0 = [(well_tmp - bds(2,2)),bds(2,2)];
    end
    y1 = well_tmp - bds(2,1);
    if y1 > bds(1,2)
        pt1 = [bds(2,1),y1];
    else
        pt1 = [(well_tmp - bds(1,2)),bds(1,2)];
    end
    pts = [pt0 ; pt1];
    plot(pts(:,1),pts(:,2),'k-','thickness',1)
end

legend(["k=0.75","k=1.25","k=1.75","k=2.25"],with_box = %t)
aaa = get("current_axes")
aaa.children(1).font_size = 3;

title(['Evolution of system: Time = ',msprintf('%3.1f',T),', q =',msprintf('%1.2f',q_vals(1)),'$ \phi =$',msprintf('%1.2f',phi),'$ p =$',msprintf('%1.2f',p)],'fontsize',3)
xlabel('Conspicuous well-being index','fontsize',3)
ylabel('Inconspicuous well-being index','fontsize',3)
